# bookmarks_pages_cheatsheets
## my _bookmarks_, _pages_, _cheatsheets..._

### ** How To make commits ** 

https://docs.google.com/document/d/1QrDFcIiPjSLDn3EL15IJygNPiHORgU1_OOAqWjiDU5Y/edit

https://ru.hexlet.io/blog/posts/naming-in-programming

https://danielkummer.github.io/git-flow-cheatsheet/

https://www.atlassian.com/git/tutorials/comparing-workflows/gitflow-workflow

### **Pages:**

https://github.com/Hexlet/ru-test-assignments

https://ru.hexlet.io/blog/posts/traps-learning



https://letsencrypt.org/

http://www.allitebooks.org/

### **Handbooks & manuals:**

https://developer.mozilla.org

https://css-tricks.com/

https://phpunit.readthedocs.io/en/8.1/

https://laravel.com/docs/5.8/collections

https://www.w3schools.com/php7/php7_mysql_connect.asp

http://www.cplusplus.com

https://nodejs.org/api/

https://www.haskell.org/

https://vuejs.org/v2/guide/
https://habr.com/en/post/204274/
http://hyperpolyglot.org

https://yaml.org/spec/1.2/spec.html

https://pip.pypa.io/en/stable/

https://docs.python.org/3/reference/import.html#import-related-module-attributes

https://github.com/pyenv/pyenv

https://docs.pipenv.org/en/latest/

https://poetry.eustace.io/

https://ipython.readthedocs.io/en/stable/index.html

https://learngitbranching.js.org/

https://habr.com/ru/post/133363/  [шпаргалка по NPM]

https://habr.com/ru/post/105495/  [основы линукс]

https://www.sao.ru/hq/sts/linux/doc/lnag/3.html#run_program  [основы линукс др.]

https://ru.hexlet.io/blog/posts/skripty-moduli-i-biblioteki  [скрипты модули и библиотеки]

https://www.sao.ru/hq/sts/linux/doc/lnag/3.html#run_program

https://docs.locust.io/en/latest/installation.html

https://proglib.io/p/otkrytye-linux-benchmarki-dlya-nagruzochnogo-testirovaniya-serverov-i-veb-prilozheniy-2019-11-01

https://www.mediacollege.com/linux/command/linux-command.html

https://docs.python.org/2/library/subprocess.html

https://www.tutorialspoint.com/python/python_variable_types.htm

https://docs.python.org/2/library/optparse.html

https://pythex.org/

https://www.digitalocean.com/community/tutorial_series/an-introduction-to-managing-dns

https://www.digitalocean.com/community/tutorials/how-to-configure-bind-as-a-private-network-dns-server-on-ubuntu-16-04

### IDE & TEXT EDITORS ###

https://www.geany.org/documentation/manual/

https://www.jetbrains.com/help/phpstorm/sharing-your-ide-settings.html#IDE_settings_sync

https://dbeaver.io/download/

https://www.extendoffice.com/documents/excel/2465-excel-shortcut-insert-or-delete-row-column-tab.html

### Utility ###

http://paletton.com

https://pingdom.com

https://figma.com

https://www.nirsoft.net/utils/mailpv.html

https://www.openshot.org

https://www.blender.org

https://mitmproxy.org/

https://www.tinybutstrong.com

https://github.com/Skrol29/opentbs

https://packagist.org/packages/tinybutstrong/opentbs?q=&p=6

https://crontab.guru

https://travis-ci.org

https://codeclimate.com

https://shields.io/

https://marketplace.digitalocean.com/

https://www.digitalocean.com/community/tutorials

https://colab.research.google.com/

### **Libs:**

https://lodash.com

https://carbon.nesbot.com

https://github.com/danielstjules/Stringy

https://github.com/tightenco/collect

https://laravel.com/docs/5.8/collections

https://ru.vuejs.org/v2/guide/index.html

https://vuetifyjs.com/en/getting-started/quick-start

https://vuejsexamples.com/

https://vuejs.org/v2/examples/index.html

https://coreui.io

### Чарты ###

https://echarts.apache.org/examples/en/index.html

https://www.chartjs.org/docs/latest/

#### not free ####

https://www.highcharts.com

### LiveSearch ###

https://autocomplete.trevoreyre.com/#/vue-component

### Selects ###

https://select2.org

https://vuetifyjs.com/en/

### Работа с текстом ###
https://www.tinybutstrong.com/opentbs.php?doc

### tests

https://www.chaijs.com/

http://phantomjs.org/

https://webdriver.io/docs/gettingstarted.html


### **Book Libraryes:**

http://www.allitebooks.org/

https://github.com/EbookFoundation/free-programming-books



### **Books:**


[Matt Zandstra: "PHP Objects, Patterns, and Practice 5th ed. Edition"](https://www.amazon.com/Objects-Patterns-Practice-MATT-ZANDSTRA/dp/1484219953/ref=sr_1_1?keywords=Zandstra+php&qid=1557613193&s=books&sr=1-1)


[UNIX and Linux System Administration Handbook](https://www.amazon.com/UNIX-Linux-System-Administration-Handbook/dp/0134277554)

### **Fundamental theory:**

[Steven S S. Skiena: "The Algorithm Design Manual"](https://www.amazon.com/Algorithm-Design-Manual-Steven-Skiena/dp/1849967202/ref=sr_1_1?qid=1557613071&refinements=p_27%3ASteven+S+S.+Skiena&s=books&sr=1-1&text=Steven+S+S.+Skiena)

### ** GIT ** ###

https://git-scm.com/book/ru/v2

### **Online courses:**

https://github.com/Hexlet/ru-test-assignments

https://refactoring.guru/ru/design-patterns


https://hexlet.io


https://codecademy.com

https://edx.com

https://www.edx.org/course/cs50s-introduction-to-computer-science

https://javarush.ru/quests/QUEST_HARVARD_CS50  (RU)

https://javarush.ru

https://freecodecamp.org

https://www.w3schools.com

https://www.coursera.org/learn/c-plus-plus-white?specialization=c-plus-plus-modern-development

https://www.coursera.org/learn/c-plus-plus-yellow?specialization=c-plus-plus-modern-development

https://www.coursera.org/specializations/razrabotka-interfeysov

https://www.coursera.org/learn/snovy-html-i-css

https://www.geeksforgeeks.org/

https://tutorial.djangogirls.org/

https://developer.mozilla.org/ru/docs/Web/CSS

https://webref.ru/layout/learn-html-css



### Notes ###

https://vk.com/@javarush-10-principov-oop-o-kotoryh-stoit-znat-kazhdomu-programmistu

https://laravel.ru/posts/1120

https://codebeautify.org/jsonviewer

https://canvasjs.com/php-charts/chart-index-data-label/

https://stackoverflow.com/questions/27221438/cron-every-day-at-6-pm

https://linuxconfig.org/keep-your-home-safe-with-cron-backups

https://www.learnenough.com/command-line-tutorial/basics

http://www.faqs.org/rfcs/rfc2617.html

http://prgssr.ru/development/tehniki-raboty-s-dom-roditelskie-dochernie-i-sosednie-elementy.html

https://www.npmjs.com/package/qrcode.vue

https://gruhn.github.io/vue-qrcode-reader/demos/DecodeAll.html

https://www.linuxbabe.com/ubuntu/install-nvidia-driver-ubuntu-18-04

https://frankfzw.wordpress.com/2014/12/23/migrate-ubuntu-14-04-from-hdd-to-ssd/

https://www.rosehosting.com/blog/how-to-install-php-7-3-on-ubuntu-16-04/

https://ru.vuejs.org/v2/cookbook/index.html

http://prgssr.ru/development/tehniki-raboty-s-dom-roditelskie-dochernie-i-sosednie-elementy.html

http://najomi.org

http://www.dejurka.ru/css/javascript_snippets/

https://fontawesome.com/v4.7.0/icon/envelope-o

https://beta.russianhackers.org

https://habr.com/en/post/204274/

https://webformyself.com/vue-vs-jquery-kak-zamenit-odno-na-drugoe/

https://proglib.io/p/7-caytov-dlya-ottachivaniya-navyka-napisaniya-sql-zaprosov-na-2019-2020-g-2019-11-13

##### open-source repo for novice ######

https://up-for-grabs.net/#/

http://issuehub.io/

https://www.firsttimersonly.com/

http://yourfirstpr.github.io/

https://github.com/mungell/awesome-for-beginners#javascript

https://www.tinybutstrong.com/manual.php#html_field_auto


### to see ###

https://www.haskell.org/documentation/ 

https://www.codewars.com/kata/who-likes-it/javascript 

https://neil.fraser.name/writing/diff/myers.pdf 

https://phpunit.de/getting-started/phpunit-8.html 

https://symfony.com/download 

https://reactjs.org/docs/handling-events.html

https://ru.hexlet.io/courses/js-setup-environment/lessons/babel/theory_unit

https://ru.hexlet.io/blog/posts/modern-js-explained

https://laracasts.com/series/laravel-from-scratch-2018

https://www.w3resource.com/mysql/date-and-time-functions/mysql-timestamp-function.php

https://developer.mozilla.org/en-US/docs/Web/API/Web_Workers_API/Using_web_workers

https://github.com/barryvdh/laravel-debugbar

https://laracasts.com/discuss/channels/laravel/how-to-load-huge-data-in-html-table-using-laravel-and-data-table

https://stackoverflow.com/questions/56456595/laravel-5-8-a-facade-root-has-not-been-set-after-homestead-restart

https://webformyself.com/optimizaciya-sql-zaprosov-dlya-uskoreniya-sajtov/

https://webdevetc.com/blog/laravel-features-you-may-not-know-about

https://tech.rgou.net/php/converting-documents-odt-doc-to-pdf-on-php-with-unoconv-libreoffice/

http://blog.nagaychenko.com/2010/11/15/рекурсивный-обход-директории-iterator/

https://tech.rgou.net/jobs/como-cobrar-como-desenvolvedor-freelancer/

https://developer.mozilla.org/en-US/docs/Web/API/Canvas_API/Tutorial/Drawing_shapes

https://horizon.laravel.com

https://http://stylus-lang.com/#css-needs-a-hero

https://curl.haxx.se/docs/httpscripting.html

https://cloud.elastic.co/deployments

https://habr.com/en/post/420351/

https://shareurcodes.com/blog/ajax-live-search-with-images-and-custom-html-in-laravel-using-vuejs

https://pusher.com/tutorials/search-laravel-vue

https://www.sourcecodester.com/tutorials/php/11876/live-search-using-vuejs-php.html

https://refactoring.guru/ru/design-patterns/history

http://www.dejurka.ru

https://m.habr.com/ru/company/mailru/blog/266811/

https://m.habr.com/ru/company/first/blog/348686/

https://habr.com/en/company/first/blog/349256/

http://schlueters.de/blog/

https://blog.selectel.com/auditing-system-events-linux/

https://www.digitalocean.com/community/tutorials/how-to-rewrite-urls-with-mod_rewrite-for-apache-on-ubuntu-16-04

#### AI ML ####

https://habr.com/en/company/datoml/blog/328468/

### temporary links for reading in free time ###

https://www.pluralsight.com/blog/software-development/best-developer-certifications

https://www.globalknowledge.com/us-en/resources/resource-library/articles/top-paying-certifications/

https://blog.teamweek.com/2018/10/the-11-best-project-management-certifications-2019/

ttps://www.businessnewsdaily.com/10733-programming-certifications.html

https://www.businessnewsdaily.com/10757-best-web-certifications.html

http://paletton.com/#uid=1000u0kw0sSkR-+qtw8zVncG5hZ

https://adventureland.events.sk.ru/#event_widgets_About-show

https://habr.com/en/company/first/blog/349256/

http://manpages.ubuntu.com/manpages/precise/man5/crontab.5.html

https://symfony.com/doc/current/components/dom_crawler.html#installation

https://ru.hexlet.io/knowledge

https://pear.php.net/package/PHP_CodeSniffer

https://stackoverflow.com/questions/34034730/how-to-enable-color-for-php-cli

https://asciinema.org/~0x4e494b

https://eslint.org/docs/user-guide/configuring

https://github.com/nodesource/distributions/blob/master/README.md#debinstall

https://www.git-tower.com/learn/git/faq/change-author-name-email

####-----------------------------

https://www.sourceallies.com/2009/11/vim-splits-an-introduction/


https://unix.stackexchange.com/questions/39226/how-to-run-a-script-with-systemd-right-before-shutdown
https://laravel.com/docs/6.x/controllers#resource-controllers
https://www.fosslinux.com/34665/15-tar-command-in-linux-uses-with-examples.htm

### see
https://w3path.com/laravel-6-multiple-authentication-system-example-tutorial/
https://laravel.ru/docs/v5/providers
https://kontext.tech/column/tools/308/how-to-install-windows-subsystem-for-linux-on-a-non-c-drive

### dancing with Windows WSL & Ubuntu 18.04

https://pureinfotech.com/install-windows-subsystem-linux-2-windows-10/

https://www.cloudbooklet.com/upgrade-php-version-to-php-7-4-on-ubuntu/
https://habr.com/ru/post/481746/
https://spys.one/en/socks-proxy-list/
https://www.howtogeek.com/howto/28609/how-can-i-tell-what-is-listening-on-a-tcpip-port-in-windows/
https://temofeev.ru/info/articles/nastroyka-okruzheniya-v-cli-wsl-windows-terminal/
https://github.com/microsoft/WSL/issues/4507
https://habr.com/ru/post/505634/
https://deb.sury.org/
https://linuxize.com/post/how-to-add-apt-repository-in-ubuntu/
https://medium.com/@lewwybogus/how-to-stop-wsl2-from-hogging-all-your-ram-with-docker-d7846b9c5b37
https://docs.microsoft.com/en-us/powershell/module/microsoft.powershell.utility/set-alias?view=powershell-7

https://github.com/MicrosoftDocs/WSL/issues/418
